args={...}
--require("odebug")

archKeywords={
	comment="#",
	enviroment="@",
	wordLenght="&WORDSIZE",
}
asmKeywords={
	comment=";",
	command="@",
	jumpLabel=":",
	jumpLabelVar="@",
	paramSeparator=",",
	strDelimiter="\"",
}
defaultArchParam={
	BYTEALIGNMENT="none",
	BYTEORDER="big",
	CHARACTERSIZE=8,
	WORDSIZE=8,
	WORDALIGNMENT="right",
}


-- for generating string with a given base
numberstring=function(number, base)
	local digits = {}
	if base<=36 then
		for i=0,9 do 
			digits[i] = string.char(string.byte('0')+i) 
		end
		for i=10,36 do 
			digits[i] = string.char(string.byte('A')+i-10) 
		end
	elseif base<=64 then
		digits={
			[0] ="A",	[1] ="B",	[2] ="C",	[3] ="D",	[4] ="E",	[5] ="F",	[6] ="G",	[7] ="H",
			[8] ="I",	[9] ="J",	[10]="K",	[11]="L",	[12]="M",	[13]="N",	[14]="O",	[15]="P",
			[16]="Q",	[17]="R",	[18]="S",	[19]="T",	[20]="U",	[21]="V",	[22]="W",	[23]="X",
			[24]="Y",	[25]="Z",	[26]="a",	[27]="b",	[28]="c",	[29]="d",	[30]="e",	[31]="f",
			[32]="g",	[33]="h",	[34]="i",	[35]="j",	[36]="k",	[37]="l",	[38]="m",	[39]="n",
			[40]="o",	[41]="p",	[42]="q",	[43]="r",	[44]="s",	[45]="t",	[46]="u",	[47]="v",
			[48]="w",	[49]="x",	[50]="y",	[51]="z",	[52]="0",	[53]="1",	[54]="2",	[55]="3",
			[56]="4",	[57]="5",	[58]="6",	[59]="7",	[60]="8",	[61]="9",	[62]="+",	[63]="/",
		}
	elseif base<=256 then
		for i=0,255 do
			digits[i]=string.char(i)
		end
	else
		error("base must be greater than 1 and less than 257 and a whole number")
	end
	local s = ""
	repeat
		local remainder = number%base
		s = digits[remainder]..s
		number = (number-remainder)/base
   	until number==0
   	return s
end

-- for generating string with a given base of a specified lenght
gSOL=function(number,length,base)
	if type(base)~="number" then
		base=10
	end
	local str=tostring(numberstring(number,base))
	--print(#str)
	if #str>length then
		--print(">",#str-length+1,str)
		str=string.sub(str,#str-length+1)
	elseif #str<length then
		--print("<",length-#str)
		str=string.rep("0",length-#str)..str
	end
	
	return str
end

--decodes a number on the form  baseNumber|actualNumber
decodeNumber=function(param,defaultBase)
	param=param or ""
	defaultBase=defaultBase or 16
	--print(param)
	if type(tonumber(param,defaultBase))=="number" then
		return true,tonumber(param,defaultBase)
	else
		local base=""
		local reason=""
		local baseEnd=0
		local number=0
		for pos=1,#param do
			local char=string.char(string.byte(param,pos))
			--io.write(char)
			if char=="|" then
				baseEnd=pos+1
				break
			elseif pos==#param then
				baseEnd=pos+1
				base=base..char
				break
			else
				base=base..char
			end
		end
		if baseEnd>#param then
			number=base
			base=tostring(defaultBase)--"10"
			--logPrint("!")
		else
			number=string.sub(param,baseEnd)
		end
		--logPrint("----",base,number)
		local baseNr=tonumber(base)
		local numberNr=0
		if baseNr==nil then 
			reason=base.." is not a valid base 10 number, assuming base is "..tostring(defaultBase)
			baseNr=defaultBase
		elseif baseNr<2 or baseNr>36 then
			--number=string.char(127)
			baseNr=defaultBase
			reason="base out of range[2,36], setting base to "..tostring(defaultBase)
		end
		numberNr=tonumber(number,baseNr)
		if numberNr==nil then
			if reason=="" then
				reason=tostring(number).." is not a valid number in base "..tostring(baseNr) 
			else
				reason=reason.." | "..tostring(number).." is not a valid number in base "..tostring(baseNr) 
			end
			return false,param,reason
		else
			return true,numberNr,reason
		end
	end
end

--checks is an item exists inside a table
isIn=function(list,item,indexValue)
	if type(indexValue)~="boolean" then
		indexValue=false
	end
	if type(list)~="table" then
		return false
	end
	local FoundAtIndex=""
	local found=false
	for index,value in pairs(list) do
		if indexValue then
			if index==item then
				found=true
				FoundAtIndex=index
				break
			end
		else
			if value==item then
				found=true
				FoundAtIndex=index
				break
			end
		end
	end
	return found,FoundAtIndex
end

--checks if a name is valid
validName=function(name)
	valid=true
	local byte=string.byte(name,1)
	local startChar=string.char(byte)
	--print(startChar)
	if string.find(startChar,"([%a_])")==nil then
		valid=false
	end
	for i=1,#name do
		byte=string.byte(name,i)
		if byte<32 or byte>126 or (isIn({" ",".","\\","\t","\r","\n","#","+","*","-","/",":",";",","},string.char(byte))) then
			valid=false
		end
	end
	--print(valid)
	return valid
end


--inline if statement
IF=function(condition,isTrue,isFalse)
	if condition then
		return isTrue
	else
		return isFalse
	end
end

--generates a lineError
lineError=function(line,error,class,file)
	class=tostring(class) or "ERROR"
	if file==nil then
		return class.." @ line "..tostring(line.lineNr).." : "..tostring(error)
	else
		return class..": "..file.." @ line "..tostring(line.lineNr).." : "..tostring(error)
	end
end

--parses a filepath
parseFilePath=function(path)
	local folder=""
	local file=""
	local extension=""

	local path=string.reverse(path) -- reverse the path for easier processing

	--finds the extension of the file
	for char in string.gmatch(path,"(.)") do
		extension=extension..char
		if char=="." then
			break
		end
	end
	path=string.gsub(path,extension,"",1) --removes the extension from the path

	-- finds the filename
	for char in string.gmatch(path,"(.)") do
		
		if char=="/" or char=="\\" then
			break
		else
			file=file..char
		end
	end
	path=string.gsub(path,file,"",1) -- removes the filename from the path

	folder=path --what remains of the path, is the folder/location

	-- as of now everything is in reverse, so it neads to be reversed
	extension=string.reverse(extension)
	file=string.reverse(file)
	folder=string.reverse(folder)
	return folder,file,extension
end

--allows for easy itteration over chars in a string
chars=function(inputString)
	local counter=0
	local maxCounter = #inputString

	return function()
		if counter<maxCounter then
			counter=counter+1
			return string.char(string.byte(inputString,counter))
		end
	end
end

separateWords=function(inputString,wordSize)
	local counter=1-wordSize
	local maxCounter=#inputString

	return function()
		counter=counter+wordSize
		if counter>=maxCounter then
			return nil
		--elseif counter+wordSize>maxCounter then
		--	return string.sub(inputString,counter,maxCounter)
		else
			return string.sub(inputString,counter,counter+wordSize-1)
		end
	end
end

writeBinFile=function(instructions,filename,enviroment)
	local tempFile=io.tmpfile()
	local outFile=io.open(filename,"wb")
	--local textOutFile=io.open("--textOutFile.txt","w")
	if outFile==nil then
		return false,"could not open file:"..filename
	end
	for i=1,#instructions do
		tempFile:write(instructions[i].bitString)
	end
	tempFile:seek("set")

	local C=0
	local k=4
	local data=tempFile:read(enviroment.archParam.WORDSIZE)
	while data~=nil do
		if #data<enviroment.archParam.WORDSIZE then
			data=data..string.rep("0",enviroment.archParam.WORDSIZE-#data)
		end
		if enviroment.archParam.BYTEALIGNMENT=="left" then
			if #data%8~=0 then
				data=data..string.rep("0",8-#data%8)
			end
		elseif enviroment.archParam.BYTEALIGNMENT=="right" then
			if #data%8~=0 then
				data=string.rep("0",8-#data%8)..data
			end
		else
			if #data%8~=0 then
				data=data..tempFile:read(8-#data%8)
			end
		end
		local bytes={}
		for byte in separateWords(data,8) do
			table.insert(bytes,byte)
		end
		if enviroment.archParam.BYTEORDER=="big" then
			for i=1,#bytes,1 do
				outFile:write(string.char(tonumber(bytes[i],2)))
				--textOutFile:write(bytes[i])
				--textOutFile:write(IF(C==k-1,"\n"," "))
				C=(C+1)%k
			end
		elseif enviroment.archParam.BYTEORDER=="little" then
			for i=#bytes,1,-1 do
				outFile:write(string.char(tonumber(bytes[i],2)))
				--textOutFile:write(bytes[i])
				--textOutFile:write(IF(C==k-1,"\n"," "))
				C=(C+1)%k
			end
		end
		data=tempFile:read(enviroment.archParam.WORDSIZE)
	end
	outFile:close()
	--textOutFile:close()
	return true
end






--table with functions for decoding archfile parameters
local archParamenters={
	PREDEFINEDVARIABLE=function(line,enviroment,file)
		if #line.words~=3 then
			return false,lineError(line,"predefined variables requires a name and a value","ERROR",file)
		end
		if not validName(line.words[2]) then
			return false,lineError(line,line.words[2].." is not a valid name for a preset Variable","ERROR",file)
		end
		local success,value,reason=decodeNumber(line.words[3],10)
		if success then
			enviroment.variables=enviroment.variables or {}
			--print(line.words[2],enviroment.variables[line.words[2]])
			if enviroment.variables[line.words[2]]==nil then
				enviroment.variables[line.words[2]]=value
			else
				print(lineError(line,line.words[2].." is already defined and wil be ignored","warning",file))
			end
		else
			return false,lineError(line,reason,"ERROR",file)
		end
		return true
	end;

	BYTEORDER=function(line,enviroment,file)
		if #line.words~=2 then
			return false,lineError(line,line.words[1].." requires a value","ERROR",file)
		end
		
		if isIn({"little","big","littleendian","bigendian"},string.lower(line.words[2])) then
			if enviroment.archParam[line.words[1]]==nil then
				enviroment.archParam[line.words[1]]=string.lower(line.words[2])
			else
				print(lineError(line,line.words[1].." is already defined and wil be ignored","warning",file))
			end
		else
			return false,lineError(line,line.words[2].." is not a valid value for "..line.words[1],"ERROR",file)
		end
		return true
	end;

	BYTEALIGNMENT=function(line,enviroment,file)
		if #line.words~=2 then
			return false,lineError(line,line.words[1].." requires a value","ERROR",file)
		end
		
		if isIn({"left","right","none"},string.lower(line.words[2])) then
			
			if enviroment.archParam[line.words[1]]==nil then
				enviroment.archParam[line.words[1]]=string.lower(line.words[2])
			else
				print(lineError(line,line.words[1].." is already defined and wil be ignored","warning",file))
			end
		else
			return false,lineError(line,line.words[2].." is not a valid value for "..line.words[1],"ERROR",file)
		end
		return true
	end;

	WORDALIGNMENT=function(line,enviroment,file)
		if #line.words~=2 then
			return false,lineError(line,line.words[1].." requires a value","ERROR",file)
		end
		
		if isIn({"left","right","none"},string.lower(line.words[2])) then
			
			if enviroment.archParam[line.words[1]]==nil then
				enviroment.archParam[line.words[1]]=string.lower(line.words[2])
			else
				print(lineError(line,line.words[1].." is already defined and wil be ignored","warning",file))
			end
		else
			return false,lineError(line,line.words[2].." is not a valid value for "..line.words[1],"ERROR",file)
		end
		return true
	end;

	WORDSIZE=function(line,enviroment,file)
		if #line.words~=2 then
			return false,lineError(line,line.words[1].." requires a value","ERROR",file)
		end
		local realNr,value,reason=decodeNumber(line.words[2],10)
		if realNr then
			if enviroment.archParam[line.words[1]]==nil then
				enviroment.archParam[line.words[1]]=value
			else
				print(lineError(line,line.words[1].." is already defined and wil be ignored","warning",file))
			end
		else
			return false,lineError(line,line.words[2].." is not a valid value for "..line.words[1].." : "..reason,"ERROR",file)
		end
		
		return true
	end;

	CHARACTERSIZE=function(line,enviroment,file)
		--print(line.line)
		if #line.words~=2 then
			return false,lineError(line,line.words[1].." requires a value","ERROR",file)
		end
		local realNr,value,reason=decodeNumber(line.words[2],10)
		if realNr then
			if enviroment.archParam[line.words[1]]==nil then
				enviroment.archParam[line.words[1]]=value
			else
				print(lineError(line,line.words[1].." is already defined and wil be ignored","warning",file))
			end
		else
			return false,lineError(line,line.words[2].." is not a valid value for "..line.words[1].." : "..reason,"ERROR",file)
		end
		
		return true
	end;

}

--calculates the lenght of a instruction in bits
instructionLenght=function(instruction,enviroment)
	
	local lenght=0
	for i=1,#instruction do
		if type(instruction[i])=="string" then
			lenght=lenght+#instruction[i]
		elseif type(instruction[i])=="number" then
			lenght=lenght+instruction[i]
		end
	end
	--print(name,"lenght=",lenght)
	if 	enviroment.archParam.WORDALIGNMENT=="left" or
		enviroment.archParam.WORDALIGNMENT=="right" then
		lenght=math.ceil(lenght/enviroment.archParam.WORDSIZE)*enviroment.archParam.WORDSIZE
	end
	return lenght
end


--opens a .arch file and reaads in the content to a table
local openArchFile=function(filePath)

	local archFile=io.open(filePath)
	local lines={}
	if archFile==nil then
		print("ERROR: unable to open file: "..filePath)
		return nil
	else
		local lineNr=0
		for line in archFile:lines() do -- reads inn all the lines
			lineNr=lineNr+1
			local blankStart=true
			local words={}
			local word=1
			for char in chars(line) do
				if (char==" " or char=="\t") and blankStart then -- trims the lines of leading whitespace and comments and clips out words

				elseif char==archKeywords.comment then --ends the line if it reaches a comment
					break
				else
					blankStart=false
					if (char==" " or char=="\t") then
						word=word+1
						blankStart=true
					else
						words[word]=(words[word] or "")..char
					end
				end
			end
			lines[lineNr]={line=line,lineNr=lineNr,significant=#words>0,words=words}
			
			lines[lineNr].enviroment=string.sub(words[1] or " ",1,1)==archKeywords.enviroment
		end
	end

	archFile:close()
	return lines
end

--parses a parameter from a instruction
local parseParameter=function(word,file)
	----print(word)
	local parameter={}
	--param,name,bits=string.match(word,"(%d-|?%x+)(%w*)%[([^%[%]]+)%]")--"([^%[%]]+)%[([^%[%]]+)%]%[([^%[%]]+)%]")
	--local number,bits	=string.match(word,"([%w|]+)%[([^%[%]]+)%]")
	local name,bits	=string.match(word,"([^%[%]]+)%[([^%[%]]+)%]")
	local param="o"
	if name==nil or bits==nil then
		return nil,word.." is not a valid parameter or litteral"
	end

	local realNr,number,reason=decodeNumber(name,10)
	--print(number,realNr,reason)

	if (not realNr) and validName(name) then
		param="p"
		--bits=bits1
	elseif realNr then
		--print("test")
		param="l"
		name=number
	elseif not validName(name) then
		return nil,name.." is not a valid name or number"
	end

	--print(param,"|"..tostring(number).."|","|"..tostring(bits).."|","|"..tostring(name).."|","|"..tostring(bits1).."|")
	if (number==nil and name==nil ) or bits==nil then
		return nil,"parameter definition should look like randomName[16], litteral definition should look like basenumber|actualNumber[32] or 16|FFFF[12]"
	end

	if param=="l" then
		parameter.type="litteral"
	elseif param=="p" then
		parameter.type="parameter"
	else
		return nil, "argument must be either litteral \"l\" or parameter \"p\""
	end
	--print(bits,tonumber(bits))
	local isNumber,bits,reason=decodeNumber(bits,10)
	if not isNumber then
		return nil, "size must be given as a number. "..reason
	elseif bits<1 then
		return nil,"size must be at least 1 bit"
	end
	parameter.size=math.floor(bits)

	parameter.name=tostring(name)
	if parameter.type=="litteral" then
		parameter.value=number
		if parameter.value==nil then
			return nil, "a litteral requires a number"
		end
	end
	-- parameter={
	-- 	type="litteral"|"parameter"
	-- 	value=number
	-- 	size=size
	-- 	name=name
	-- }

	--print(word,param,name,bits)
	return parameter,nil
end


--parses a instruction from a line from the .arch file
local parseInstruction=function(line,file)
	local instruction={}
	--print(line.words[1],archKeywords.wordLenght)

	if #line.words<3 then
		return nil,lineError(line,"an instruction requires a mnemonic, the lenght of the instruction and at least 1 litteral/parameter","ERROR",file)
	end
	if not validName(line.words[1]) then
		return nil,lineError(line,line.words[1].." is not a valid mnemonic","ERROR",file)
	end
	instruction.name=line.words[1]

	--if tonumber(line.words[2])== nil then
	--	return nil,"ERROR @ line "..tostring(line.lineNr).." : lenght of instruction must be a number"
	--end

	local isNumber,size,reason=decodeNumber(line.words[2],10)
	if not isNumber then
		return nil,"ERROR @ line "..tostring(line.lineNr).." : instruction size must be a number : "..reason
	elseif size<1 then
		return nil,"ERROR @ line "..tostring(line.lineNr).." : instruction size of "..tonumber(size).." is less than the minimum of 1"
	elseif reason~=nil and #reason>1 then
		print(lineError(line,reason,"warning",file))
	end
	instruction.size=size--converting lenght to a number
	instruction.parameters={}

	for i=3,#line.words do--decoding each parameter/litteral
		result,reason=parseParameter(line.words[i],file)
		if result==nil then
			return nil,lineError(line,"parameter "..tostring(i-2).." : "..reason,"ERROR",file)
		else
			table.insert(instruction.parameters,result)
		end
	end

	local result={paramNames={},name=instruction.name}
	local sumOfSize=0

	for i=1,#instruction.parameters do
		if instruction.parameters[i].type=="litteral" then
			table.insert(result,gSOL(instruction.parameters[i].value,instruction.parameters[i].size,2))
			table.insert(result.paramNames,instruction.parameters[i].name)
		elseif instruction.parameters[i].type=="parameter" then
			table.insert(result,instruction.parameters[i].size)
			table.insert(result.paramNames,instruction.parameters[i].name)
		end
		sumOfSize=sumOfSize+instruction.parameters[i].size
	end

	if sumOfSize<instruction.size then
		if not isIn(archKeywords,result.name) then
			print(lineError(line,result.name.." : parameters are shorter than specified lenght, padding with zeros","warning",file))
		end
		table.insert(result,string.rep("0",instruction.size-sumOfSize))
	elseif sumOfSize>instruction.size and not isIn(archKeywords,result.name) then
		return nil,(lineError(line,result.name.." : parameters are longer than specified lenght","ERROR",file))
	end


	
	return result
end

--parses an enviromentVariable
local parseEnviromentVariable=function(line,enviroment,file)
	enviroment.archParam=enviroment.archParam or {}
	if #line.words[1]<=1 then
		table.remove(line,1)
	else
		line.words[1]=string.sub(line.words[1],2)
	end
	
	if archParamenters[line.words[1]]~=nil then
		local success,reason=archParamenters[line.words[1]](line,enviroment,file)
		return success,reason
	else
		return false,lineError(line,line.words[1].." is not a valid enviromentVariable","warning",file)
	end

	return true
end

--only function to be awailable outside this file
parseArchFile=function(filePath,enviroment)
	local instructions={}
	local lines=openArchFile(filePath)
	if lines==nil then
		return nil
	end
	local _,fileName,ext=parseFilePath(filePath)
	fileName=fileName..ext
	for i=1,#lines do
		if lines[i].significant and not lines[i].enviroment then

			local result,error=parseInstruction(lines[i],fileName)
			if result==nil then
				print(error)
				return nil
			else
				if instructions[result.name]~=nil then
					print(lineError(lines[i],result.name.." already exists and is ignored","warning",fileName))
				else

					instructions[result.name]=result
					--print(result.name,"added")
					
					instructions[result.name].name=nil
				end
			end
		elseif lines[i].significant and lines[i].enviroment then
			local success,reason=parseEnviromentVariable(lines[i],enviroment,fileName)
			if not success then
				print(reason)
				return nil
			end
		end
	end
	return instructions
end

-- table containing all the valid assemble commands
local Commands={
	DEFINE=function(command,enviroment,file)
		enviroment.variables=enviroment.variables or {}
		
		if #command.words~=3 then
			print(lineError(command,"DEFINE requires a name and a value","warning",file))
			return true
		end
		if not validName(command.words[2]) then
			print(lineError(command,command.words[2].." is not a valid variableName","warning",file))
			return true
		end
		realNr,value,reason=decodeNumber(command.words[3])
		if not realNr then
			print(lineError(command,reason,"warning",file))
			return true
		end
		if enviroment.variables[command.words[2]]==nil then
			enviroment.variables[command.words[2]]=value
		else
			print(lineError(command,command.words[2].." already exists and is ignored","warning",file))
		end
		return true
	end;
}

--resolves all the commands
resolveCommands=function(commands,enviroment,file)
	enviroment=enviroment or {}
	for i=1,#commands do
		if Commands[commands[i].words[1]]==nil then
			return false,lineError(commands[i],commands[i].words[1].." is not a valid command","warning",file)
		end
		success,reason=Commands[commands[i].words[1]](commands[i],enviroment,file)
		if not success then
			return false,reason
		end
	end
	return true
end

--determines if a parameter is a valid string
isString=function(param)
	param=tostring(param)
	if 	string.sub(param,1,1)	==asmKeywords.strDelimiter and
		string.sub(param,-1)	==asmKeywords.strDelimiter then
		return true
	else
		return false
	end
end

isVariable=function(word,enviroment)
	return enviroment.variables[word]~=nil
end

isJumpLabel=function(word,enviroment)
	if string.sub(word,1,1)==asmKeywords.jumpLabelVar then
		if enviroment.jumpLabels[string.sub(word,2)]~=nil then
			return true
		else
			return false
		end
	else
		return false
	end
end

--gets the binaryString from a given parameter
getBinaryString=function(param,lenght,instructions,enviroment)
	local bitString={}
	local realNr,value,reason=decodeNumber(param,16)
	--print(realNr,value,reason,param)
	if isString(param) then
		param=string.sub(param,2,-2)
		for char in chars(param) do
			table.insert(
				bitString,
				gSOL(
					string.byte(char,1),
					8,
					2
				)
			)
		end
		bitString=table.concat(bitString)
		if #bitString>lenght then
			return string.sub(bitString,1,lenght)
		elseif #bitString<lenght then
			return bitString..string.rep("0",lenght-#bitString)
		else
			return bitString
		end
	elseif isVariable(param,enviroment) then
		return gSOL(enviroment.variables[param],lenght,2)
	elseif isJumpLabel(param,enviroment) then
		return gSOL(instructions[enviroment.jumpLabels[string.sub(param,2)]].wordPos,lenght,2)
	elseif realNr then
		return gSOL(value,lenght,2)
	else
		return nil,reason
	end
end

--generates the binary code for all instructions
getBinaryCodes=function(instructions,enviroment,file)
	for iNr=1,#instructions do
		local paramNr=1
		--paramString
		for word=1,#instructions[iNr].code do
			if type(instructions[iNr].code[word])=="number" then
				paramNr=paramNr+1
				--print(instructions[iNr].words[paramNr])
				if instructions[iNr].words[paramNr]==nil then
					return false,lineError(
						instructions[iNr],
						"parameter #"..tostring(paramNr-1).." "..instructions[iNr].code.paramNames[word].." : is missing",
						"ERROR",
						file
						)
				end
				local tempBitString=getBinaryString(
					instructions[iNr].words[paramNr],
					instructions[iNr].code[word],
					instructions,
					enviroment
				)
				if tempBitString==nil then
					return false,lineError(
						instructions[iNr],
						"parameter nr:"..tostring(paramNr-1).." : "..instructions[iNr].words[paramNr].." is not a valid number, string, variabel or jumpLabel",
						"ERROR",
						file
						)
				end
				if #tempBitString~=instructions[iNr].code[word] then
					print("#"..tempBitString,"~=",instructions[iNr].code[word])
				end
				

				instructions[iNr].code[word]=tempBitString
			end
		end
		local tempTotalBitString=table.concat(instructions[iNr].code)
		if #tempTotalBitString%enviroment.archParam.WORDSIZE~=0 then
			if enviroment.archParam.WORDALIGNMENT=="right" then 
				tempTotalBitString=string.rep("0",enviroment.archParam.WORDSIZE-#tempTotalBitString%enviroment.archParam.WORDSIZE)..tempTotalBitString
			elseif enviroment.archParam.WORDALIGNMENT=="left" then 
				tempTotalBitString=tempTotalBitString..string.rep("0",enviroment.archParam.WORDSIZE-#tempTotalBitString%enviroment.archParam.WORDSIZE)
			end
		end
		instructions[iNr].bitString=tempTotalBitString
	end
	return true
end


--finds the position of each instruction
getBytePos=function(instructions,opcodes,enviroment,file)
	local pos=0
	for i=1,#instructions do
		if opcodes[instructions[i].words[1]]==nil then
			return false,lineError(instructions[i],instructions[i].words[1].." is not a valid instruction","ERROR",file)
		end
		instructions[i].code={}
		for k,v in pairs(opcodes[instructions[i].words[1]]) do
			instructions[i].code[k]=v
		end
		instructions[i].bitPos=pos
		instructions[i].wordPos=math.floor(instructions[i].bitPos/enviroment.archParam.WORDSIZE)
		

		pos=pos+instructionLenght(opcodes[instructions[i].words[1]],enviroment)
	end
	return true
end

-- opens and reads in the content of a file
-- removes comments and splits up words
-- classifies each line into assembleCommand|jumpLabel|instruction
local openAsmFile=function(filePath)
	local _,name,ext=parseFilePath(filePath)
	name=name..ext
	local asmFile=io.open(filePath)
	local lines={}
	if asmFile==nil then
		print("ERROR: unable to open file: "..filePath)
		return nil
	else
		local lineNr=0
		for line in asmFile:lines() do -- reads inn all the lines
			lineNr=lineNr+1
			local blankStart=true
			local words={}
			local word=1
			local instr=false

			for char in chars(line) do
				if 	(char==" " or 
					char=="\t" or 
					(word>1 and char==asmKeywords.paramSeparator)) and 
					( not instr ) and 
					blankStart then -- trims the lines of leading whitespace and comments and clips out words

				elseif char==asmKeywords.comment then --ends the line if it reaches a comment
					break

				elseif char==asmKeywords.strDelimiter then	--makes sure that the whole string always gets its own parameter
					
					--starts a new word if a string delimiter is encountered
					--without a whitespace character infront of it
					if not instr and not blankStart then
						word=word+1
					end
					
					words[word]=(words[word] or "")..char
					instr=not instr

					--starts a new word if a string ends
					if not instr then
						word=word+1
						blankStart=true
					end

				elseif (word<2 and char==asmKeywords.jumpLabel) then	--splits jumplabels from instructions
					
					words[word]=(words[word] or "")..char
					word=word+1
				
				else
					blankStart=false
				
					if 	(
							char==" " or 
							char=="\t" or 
							(word>1 and	char==asmKeywords.paramSeparator)
						) and 
						not instr then

						word=word+1
						blankStart=true
				
					else
						words[word]=(words[word] or "")..char
				
					end
				end
			end

			lines[lineNr]={
				line=line,
				lineNr=lineNr,
				words=words
			}
			
			if instr then
				lines[lineNr].words[#lines[lineNr].words]=lines[lineNr].words[#lines[lineNr].words].."\""
				print(lineError(lines[lineNr],"unterminated string is terminated at end of line","warning",name))
			end
			--checks if it is a command for the assembler
			lines[lineNr].assembleCommand=string.sub(words[1] or "_",1,1) == asmKeywords.command

			--checks if it is a jumpLabel
			lines[lineNr].jumpLabel=	string.sub(words[1] or "_",-1) == asmKeywords.jumpLabel 
										and not lines[lineNr].assembleCommand

			--checks if it is a instruction
			lines[lineNr].instruction=	IF(lines[lineNr].jumpLabel,#words>1,#words>0)
										and not lines[lineNr].assembleCommand
		end
	end

	asmFile:close()
	return lines
end

--separates commands from instructions
local separateCommands=function(lines,file)
	local assembleCommands={}
	local instructions={}

	for i=1,#lines do
		
		if lines[i].assembleCommand then
			lines[i].words[1]=string.sub(lines[i].words[1],2)
			if lines[i].words[1]=="" then
				table.remove(lines[i].words,1)
			end
			--print(lines[i].line,"command")
			if #lines[i].words>0 then
				table.insert(assembleCommands,lines[i])
			else
				print(lineError(lines[i],"empty command statement is ignored","warning",file))
			end
		elseif lines[i].instruction or lines[i].jumpLabel then
			--print(lines[i].line,"instruction")
			table.insert(instructions,lines[i])
		end
	end

	return assembleCommands,instructions
end

--removes jumpLabels from instructions
local separateJumpLabels=function(instructionsMixed,file)
	local jumpLabels={}
		--["jumpLabel"]=lineNr
	local instructions={}
	local instructionNr=0

	for i=1,#instructionsMixed do
		if instructionsMixed[i].jumpLabel then
			if instructionsMixed[i].instruction then
				local label=string.sub(
					instructionsMixed[i].words[1]
					,1,-2
				)
				table.remove(instructionsMixed[i].words,1)
				table.insert(instructions,instructionsMixed[i])
				--print(label,#instructions,instructionsMixed[i].lineNr)
				if jumpLabels[label]==nil then
					jumpLabels[label]=#instructions
				else
					print(lineError(instructionsMixed[i],"label "..label.." already exists and is ignored","warning",file))
				end
			else
				local label=string.sub(
					instructionsMixed[i].words[1]
					,1,-2
				)
				if jumpLabels[label]==nil then
					jumpLabels[label]=#instructions+1
				else
					print(lineError(instructionsMixed[i],"label "..label.." already exists and is ignored","warning",file))
				end
			end
		elseif instructionsMixed[i].instruction then
			table.insert(instructions,instructionsMixed[i])
		end
	end
	return instructions,jumpLabels
end

getJumpLabelWordPos=function(jumpLabels,instructions)
	for label,instruction in pairs(jumpLabels) do
		jumpLabels[label]=instructions[instruction].wordPos
	end
end

parseAsmFile=function(filePath,enviroment)
	_,fileName,ext=parseFilePath(filePath)
	fileName=fileName..ext
	local lines=openAsmFile(filePath)
	if lines==nil then
		return nil
	end
	local commands,instructionsRaw=separateCommands(lines,fileName)
	local instructions,jumpLabels=separateJumpLabels(instructionsRaw,fileName)
	enviroment.jumpLabels=jumpLabels
	return commands,instructions,jumpLabels,lines
end

-- executable code below this line

asmFile=args[1] or "default.asm"--"test.asm"
archFile=args[2] or "default.arch"--"test.arch"

folder,name,ext=parseFilePath(asmFile)

binFile=(folder or "")..(name or "")..".bin"--"test.bin"


enviroment={archParam={}}

commands,instructions,jumpLabels,instructionsRaw=parseAsmFile(asmFile,enviroment)

opcodes=parseArchFile(archFile,enviroment)
--odebug.dumpFile("commands","dump\\commands.txt")
--odebug.dumpFile("instructions","dump\\instructions.txt")
--odebug.dumpFile("jumplabels","dump\\jumplabels.txt")
--odebug.dumpFile("instructionsRaw","dump\\instructionsRaw.txt")

--sets default values in the archparams
for k,v in pairs(defaultArchParam) do
	if enviroment.archParam[k]==nil then
		enviroment.archParam[k]=v
	end
end


success=commands~=nil and
		instructions~=nil and
		jumpLabels~=nil and
		opcodes~=nil

if success then
	success,reason=getBytePos(instructions,opcodes,enviroment,asmFile)
	if not success then
		print(reason)
	end
end
if success then
	success,reason=resolveCommands(commands,enviroment,asmFile)
	if not success then
		print(reason)
	end
end
if success then
	success,reason=getBinaryCodes(instructions,enviroment,asmFile)
	if not success then
		print(reason)
	end
end
if success then
	success,reason=writeBinFile(instructions,binFile,enviroment)
	if not success then
		print(reason)
	end
end
--odebug.dumpFile("enviroment","dump\\enviroment.txt")
if not success then
	print("Fix mentioned ERRORs before the result will be written to file")
end



---[[
if success and string.lower(args[3] or "")=="debug" then
	totalString=""
	for i=1,#instructions do
		totalString=totalString..instructions[i].bitString
	end
	f=io.open("debug.txt","w")
	for i=1,#instructionsRaw do
		local tempLine=""
		local tempCode=""
		for word=1,#instructionsRaw[i].words do
			tempLine=tempLine..instructionsRaw[i].words[word].." "
		end
		local tempStr=gSOL(instructionsRaw[i].lineNr,3,10).." : "..tempLine.."\n\t"
		if instructionsRaw[i].bitString~=nil then
			for word in separateWords(instructionsRaw[i].bitString,enviroment.archParam.WORDSIZE) do
				tempCode=tempCode..word.." "
			end
			--tempStr=tempStr..gSOL(instructionsRaw[i].wordPos,8,16).." : "..instructionsRaw[i].bitString
			tempStr=tempStr..gSOL(instructionsRaw[i].wordPos,8,16).." : "..tempCode
		end
		f:write(tempStr)
		f:write("\n")
	end
	f:close()
	print("see debug.txt for more details")
end
--]]
